=== modified file 'assembly2lib.py'
--- assembly2lib.py	2017-04-29 20:07:18 +0000
+++ assembly2lib.py	2017-04-29 20:45:27 +0000
@@ -435,7 +435,7 @@
     if pos != None:
         return numpy.array(pos)
     else:
-        raise NotImplementedError,"getSubElementPos Failed! Locals:\n%s" % formatDictionary(locals(),' '*4)
+        raise NotImplementedError("getSubElementPos Failed! Locals:\n%s" % formatDictionary(locals(),' '*4))
 
     
 def getSubElementAxis(obj, subElementName):
@@ -478,6 +478,6 @@
     if axis != None:
         return numpy.array(axis)
     else:
-        raise NotImplementedError,"getSubElementAxis Failed! Locals:\n%s" % formatDictionary(locals(),' '*4)
+        raise NotImplementedError("getSubElementAxis Failed! Locals:\n%s" % formatDictionary(locals(),' '*4))
 
 

=== modified file 'assembly2solver.py'
--- assembly2solver.py	2017-04-29 20:07:18 +0000
+++ assembly2solver.py	2017-04-29 20:45:27 +0000
@@ -108,13 +108,13 @@
             elif constraintObj.Type == 'sphericalSurface':
                 constraintSystem = VertexUnion(constraintSystem,  *cArgs, constraintValue=0)
             else:
-                raise NotImplementedError, 'constraintType %s not supported yet' % constraintObj.Type
+                raise NotImplementedError('constraintType %s not supported yet' % constraintObj.Type)
             if cache:
                 cache.record_levels.append( constraintSystem.numberOfParentSystems() )
-        except Assembly2SolverError, msg:
+        except Assembly2SolverError as e:
             if printErrors:
                 FreeCAD.Console.PrintError('UNABLE TO SOLVE CONSTRAINTS! info:')
-                FreeCAD.Console.PrintError(msg)
+                FreeCAD.Console.PrintError(e)
             solved = False
             break
         except:

=== modified file 'cache_assembly2.py'
--- cache_assembly2.py	2017-04-29 20:07:18 +0000
+++ cache_assembly2.py	2017-04-29 20:45:27 +0000
@@ -54,7 +54,7 @@
             new_vM = rootSystem.variableManager
             old_vM = self.result.variableManager
             for objName in old_vM.index.keys():
-                if new_vM.index.has_key( objName ):
+                if obj_name in new_vM.index:
                     i_new = new_vM.index[ objName ]
                     i_old = old_vM.index[ objName ]
                     new_vM.X[ i_new: i_new+6] = old_vM.X[ i_old: i_old+6 ]
@@ -177,7 +177,7 @@
     #/preparing to copy
     try:
         new_sys = copy.deepcopy( sys)
-    except RuntimeError, msg:
+    except RuntimeError as msg:
         debugPrint(1, '******** cache copy error: %s' % msg)
         debugPrint(1,'trying to determine were the object causing the crash is')
         for node in tree:
@@ -223,7 +223,7 @@
             if not id(d) in history:
                 try:
                     d.migrate_to_new_variableManager( new_vM )
-                except AttributeError,msg:
+                except AttributeError as msg:
                     raise NotImplementedError,"%s.migrate_to_new_variableManager" % d
                 history.add( id(d) )
 

=== modified file 'constraintSystems.py'
--- constraintSystems.py	2017-04-29 20:07:18 +0000
+++ constraintSystems.py	2017-04-29 20:45:27 +0000
@@ -93,7 +93,7 @@
         if abs( self.constraintEq_value( self.variableManager.X) ) > tol: #constraint violated
             self.solveConstraintEq_dofs = [ d for d in self.parentSystem.degreesOfFreedom + self.sys2.degreesOfFreedom  if not getattr(d,'locked',False) ]
             if len(self.solveConstraintEq_dofs) == 0: 
-                raise Assembly2SolverError,"%s no degrees-of-freedom to adjust to satify constraints:\n%s" % (self.str(), self.strSystemTree())
+                raise Assembly2SolverError("%s no degrees-of-freedom to adjust to satify constraints:\n%s" % (self.str(), self.strSystemTree()))
             else:
                 if self.analyticalSolution(): #if analytical solution then will update X
                 #if False:
@@ -119,7 +119,7 @@
                         )
                     self.constraintEq_setY(yOpt) #this will automatically update X
             if abs( self.constraintEq_value(self.variableManager.X) ) > tol:
-                raise Assembly2SolverError,"%s abs( self.constraintEq_value(self.X) ) > tol [%e > %e]. Constraint Tree:\n%s" % (self.str(), abs( self.constraintEq_value(self.variableManager.X) ), tol, self.strSystemTree())
+                raise Assembly2SolverError("%s abs( self.constraintEq_value(self.X) ) > tol [%e > %e]. Constraint Tree:\n%s" % (self.str(), abs( self.constraintEq_value(self.variableManager.X) ), tol, self.strSystemTree()))
         else:
             pass
             #debugPrint(4+PLO, '    solveConstraintEq for %s already satisfied, neither numerical or analytical solution required' % self.str())
@@ -152,16 +152,16 @@
         if debugPrint.level >= 6+PLO: dp('constraintEq_f, X %s, f(X) %s' % (self.variableManager.X,f_X))
         return f_X
     def constraintEq_value( self, X ):
-        raise Assembly2SolverError, 'ConstraintSystemPrototype not supposed to be called directly'
+        raise Assembly2SolverError('ConstraintSystemPrototype not supposed to be called directly')
 
     def analyticalSolution(self):
         return False
 
     def generateDegreesOfFreedomAnalytically( self ):
-        raise Assembly2SolverError, 'ConstraintSystemPrototype not supposed to be called directly'
+        raise Assembly2SolverError('ConstraintSystemPrototype not supposed to be called directly')
 
     def updateDegreesOfFreedomAnalytically( self ):
-        raise Assembly2SolverError, 'ConstraintSystemPrototype not supposed to be called directly'                    
+        raise Assembly2SolverError('ConstraintSystemPrototype not supposed to be called directly')
 
     def getPos(self, objName, subElement):
         obj =  self.variableManager.doc.getObject( objName )
@@ -251,7 +251,7 @@
                              return 
 
                 
-        raise NotImplementedError,'generateDegreesOfFreedomNumerically Logic not programmed for the reduction of degrees of freedom with df_dy=%s, self.solveConstraintEq_dofs:\n%s' % (df_dy,'\n'.join(d.str('  ') for d in self.solveConstraintEq_dofs ))
+        raise NotImplementedError('generateDegreesOfFreedomNumerically Logic not programmed for the reduction of degrees of freedom with df_dy=%s, self.solveConstraintEq_dofs:\n%s' % (df_dy,'\n'.join(d.str('  ') for d in self.solveConstraintEq_dofs )))
 
     def updateDegreesOfFreedomNumerically( self ):
         if self.generateDegreesOfFreedomNumerically_case == 0:
@@ -668,7 +668,7 @@
             if debugPrint.level >= 1: dp('numpy.isnan(dist)')
             if debugPrint.level >= 1: dp('  locals %s' % formatDictionary(locals(),' '*6) )
             if debugPrint.level >= 1: dp('  %s.__dict %s' % (self.label, formatDictionary( self.__dict__,' '*6 ) ) )   
-            raise ValueError, ' assembly2 AxisDistanceUnion numpy.isnan(dist) check console for details'
+            raise ValueError(' assembly2 AxisDistanceUnion numpy.isnan(dist) check console for details')
         return dist - self.constraintValue
 
     def analyticalSolution(self):
@@ -710,7 +710,7 @@
         #first try to look for an object which has 3 linear motion degrees of freedom'
         success = False
         if self.constraintValue != 0:
-            raise NotImplementedError, '%s self.constraintValue != 0 not implemented yet' % self.label
+            raise NotImplementedError('%s self.constraintValue != 0 not implemented yet' % self.label)
         vM = self.variableManager
         axisVector = vM.rotate( self.obj1Name, self.a1_r, vM.X )
         self.dof_added = False

=== modified file 'degreesOfFreedom.py'
--- degreesOfFreedom.py	2017-04-29 20:07:18 +0000
+++ degreesOfFreedom.py	2017-04-29 20:45:27 +0000
@@ -96,7 +96,7 @@
             if check_R_to_align_axis:
                 print('NOTE: checking AxisRotationDegreeOfFreedom self.R_to_align_axis')
                 if norm(  dotProduct(self.R_to_align_axis, axis_r) - axis ) > 10**-12:
-                    raise ValueError, " dotProduct(self.R_to_align_axis, axis_r) - axis ) [%e] > 10**-12" % norm(  dotProduct(self.R_to_align_axis, axis_r) - axis )
+                    raise ValueError(" dotProduct(self.R_to_align_axis, axis_r) - axis ) [%e] > 10**-12" % norm(  dotProduct(self.R_to_align_axis, axis_r) - axis ))
             
             if not hasattr(self, 'x_ref_r'):
                 self.x_ref_r, self.y_ref_r  =  plane_degrees_of_freedom( axis_r )
@@ -130,10 +130,10 @@
         if refApproach:
             v = dotProduct( R_effective, self.x_ref_r)
             if tol != None and abs( dotProduct(v, self.axis) ) > tol:
-                raise ValueError, "abs( dotProduct(v, self.axis) ) > %e [error %e]" % (tol, abs( dotProduct(v, self.axis) ))
+                raise ValueError("abs( dotProduct(v, self.axis) ) > %e [error %e]" % (tol, abs( dotProduct(v, self.axis) )))
             angle = self.vectorsAngleInDofsCoordinateSystem(v)
         else: 
-            raise NotImplementedError,"does not work yet"
+            raise NotImplementedError("does not work yet")
             R_effective = azimuth_elevation_rotation_matrix( *self.vM.X[i+3:i+6] )
             R_about_axis = self.determine_R_about_axis(R_effective)
             axis, angle =  rotation_matrix_axis_and_angle( R_about_axis )
@@ -215,7 +215,7 @@
             d.setValue(value)
             returnedValue = d.getValue()
             if abs(returnedValue - value) > tol :
-                raise ValueError,"d.getValue() - value != %1.0e, [diff %e]" % (tol, returnedValue - value)
+                raise ValueError("d.getValue() - value != %1.0e, [diff %e]" % (tol, returnedValue - value))
 
     print('\nTesting AxisRotationDegreeOfFreedom')
     tol = 10**-14
@@ -232,4 +232,4 @@
             returnedValue = d.getValue()
             print('  d.getValue() %f value %f, diff %e' % (returnedValue, value, returnedValue - value))
             if abs(returnedValue - value) > tol :
-                raise ValueError,"d.getValue() - value != %1.0e, [diff %e]" % (tol, returnedValue - value)
+                raise ValueError("d.getValue() - value != %1.0e, [diff %e]" % (tol, returnedValue - value))

=== modified file 'degreesOfFreedomAnimation.py'
--- degreesOfFreedomAnimation.py	2016-11-17 18:24:34 +0000
+++ degreesOfFreedomAnimation.py	2017-04-29 20:45:27 +0000
@@ -79,7 +79,7 @@
          self._startAnimation( [d for d in self.constraintSystem.degreesOfFreedom] )
 
     def reject(self): #or more correctly close, given the button settings
-        if  moduleVars.has_key('animation'):
+        if  'animation' in moduleVars:
             moduleVars['animation'].timer.stop()
             self.constraintSystem.variableManager.updateFreeCADValues(moduleVars['animation'].X_before_animation)
             del moduleVars['animation']

=== modified file 'importPart.py'
--- importPart.py	2017-04-29 20:07:18 +0000
+++ importPart.py	2017-04-29 20:45:27 +0000
@@ -575,7 +575,7 @@
             return diff.error1 == 0 and diff.error2 == 0
         else:
             return False
-    except (IndexError, AttributeError), msg:
+    except (IndexError, AttributeError) as e:
         return False
 
 

=== modified file 'lib3D.py'
--- lib3D.py	2017-04-29 20:07:18 +0000
+++ lib3D.py	2017-04-29 20:45:27 +0000
@@ -14,7 +14,7 @@
     elif abs(v) -1 < allowableNumericalError:
         return pi/2 if v > 0 else -pi/2
     else:
-        raise ValueError,"arcsin2 called with invalid input of %s" % v
+        raise ValueError("arcsin2 called with invalid input of %s" % v)
 
 def arccos2( v, allowableNumericalError=10**-1 ):
     if -1 <= v and v <= 1:
@@ -22,7 +22,7 @@
     elif abs(v) -1 < allowableNumericalError:
         return 0 if v > 0 else pi
     else:
-        raise ValueError,"arccos2 called with invalid input of %s" % v
+        raise ValueError("arccos2 called with invalid input of %s" % v)
 
 def normalize( v ):
     return v / norm(v)
@@ -216,7 +216,7 @@
         print('rotation_matrix_to_euler_ZYX_check_answer:')
         print('    norm(R - euler_ZYX_rotation_matrix( angle1, angle2, angle3)) %e' % error)
     if error > tol:
-         raise RuntimeError,'rotation_matrix_to_euler_ZYX check failed!. locals %s' % locals()
+         raise RuntimeError('rotation_matrix_to_euler_ZYX check failed!. locals %s' % locals())
 def rotation_matrix_to_euler_ZYX_2(R, debug=False):
     axis, angle = rotation_matrix_axis_and_angle_2(R)
     q_1, q_2, q_3, q_0 = quaternion(angle, *axis)
@@ -243,7 +243,7 @@
         msg = 'abs(a % pi) > angle_pi_tol and abs(pi - (a % pi)) > angle_pi_tol'
         axis, angle = rotation_matrix_axis_and_angle_2( R, errorThreshold=errorThreshold, debug=debug, msg=msg)
     if numpy.isnan( angle ):
-        raise RuntimeError,'locals %s' % locals() 
+        raise RuntimeError('locals %s' % locals() )
     return axis, angle
 def rotation_matrix_axis_and_angle_2(R, debug=False, errorThreshold=10**-7, msg=None):
     w, v = numpy.linalg.eig(R) #this method is not used at the primary method as numpy.linalg.eig does not return answers in high enough precision
@@ -264,7 +264,7 @@
             R_pickle_str = pickle.dumps(R)
             #R_abs_minus_identity = abs(R) - numpy.eye(3)
             print(R*R.transpose())
-            raise ValueError, 'rotation_matrix_axis_and_angle_2: no solution found! locals %s' % str(locals())
+            raise ValueError( 'rotation_matrix_axis_and_angle_2: no solution found! locals %s' % str(locals()))
     return axis, angle
 
 
@@ -288,7 +288,7 @@
         print(P)
         print(' error norm from eye(3) : %e' % error)
     if error > tol:
-        raise RuntimeError,'plane_degrees_of_freedom check failed!. locals %s' % locals()
+        raise RuntimeError('plane_degrees_of_freedom check failed!. locals %s' % locals())
 
 def planeIntersection( normalVector1, normalVector2, debug=False, checkAnswer=False ):
     return normalize ( crossProduct(normalVector1, normalVector2) )
@@ -304,7 +304,7 @@
         error2 = abs(dotProduct( normalVector2, d*t ))
         if disp:print('    d*(%1.1f) -> error1 %e, error2 %e' % (t, error1, error2) )
         if error1 > tol or error2 > tol:
-            raise RuntimeError,' planeIntersection check failed!. locals %s' % locals()
+            raise RuntimeError(' planeIntersection check failed!. locals %s' % locals())
 
 
 
@@ -587,14 +587,14 @@
             angle_out = -angle_out
             axis_out = -axis_out
         if norm(axis - axis_out) > 10**-12 or norm(angle - angle_out) > 10**-9:
-            raise ValueError, "norm(axis - axis_out) > 10**-12 or norm(angle - angle_out) > 10**-9. \n  in:  axis %s, angle %s\n  out: axis %s, angle %s" % (axis,angle,axis_out,angle_out) 
+            raise ValueError("norm(axis - axis_out) > 10**-12 or norm(angle - angle_out) > 10**-9. \n  in:  axis %s, angle %s\n  out: axis %s, angle %s" % (axis,angle,axis_out,angle_out))
     print('testing axis_to_azimuth_and_elevation_angles & azimuth_and_elevation_angles_to_axis')
     for i,testcase in enumerate(testcases):
         axis, angle = testcase
         a,e = axis_to_azimuth_and_elevation_angles(*axis)
         axis_out = azimuth_and_elevation_angles_to_axis( a, e)
         if norm(axis - axis_out) > 10**-12:
-            raise ValueError, "norm(axis - axis_out) > 10**-12. \n  in:  axis %s \n  azimuth %f, elavation %f \n  out: axis %s" % (axis,a,e,axis_out)
+            raise ValueError("norm(axis - axis_out) > 10**-12. \n  in:  axis %s \n  azimuth %f, elavation %f \n  out: axis %s" % (axis,a,e,axis_out))
 
 
     print('\nchecking distance_between_axes function')
@@ -744,7 +744,7 @@
         print('  quatrian  v_ref %s, v %s, error %1.3e' % ( v, v_ref, error ) )
 
         if error > 10**-9 :
-            raise ValueError, 'Failure for v_ref %s, v %s, error %1.3e' % ( v, v_ref, error )
+            raise ValueError('Failure for v_ref %s, v %s, error %1.3e' % ( v, v_ref, error ))
     print('all test case passed')
 
     print('distance between axis and point')
@@ -787,5 +787,5 @@
             prettyPrintArray(U, '  ', '%1.2f')
             print('U U^T:')
             prettyPrintArray( W, '  ', '%1.2f' )
-            raise ValueError, 'gram_schmidt_orthonormalization test failed, error %e > 10**-9' % error
+            raise ValueError('gram_schmidt_orthonormalization test failed, error %e > 10**-9' % error)
     print('..passed')

=== modified file 'solverLib.py'
--- solverLib.py	2017-04-29 20:07:18 +0000
+++ solverLib.py	2017-04-29 20:45:27 +0000
@@ -127,8 +127,8 @@
             b = numpy.array([b])
         try:
             x_c, residuals, rank, s = numpy.linalg.lstsq( A, b)
-        except ValueError, msg:
-            printF('  solve_via_Newtons_method numpy.linalg.lstsq failed: %s.  Setting x_c = x' % str(msg)) 
+        except ValueError as e:
+            printF('  solve_via_Newtons_method numpy.linalg.lstsq failed: %s.  Setting x_c = x' % str(e)) 
             x_c = x
         if debugPrintLevel > 1:
             if singleEq:
@@ -172,7 +172,7 @@
         return self.f_x[-1]
     def addNote(self, note):
         key = len(self.x)
-        assert not self.notes.has_key(key)
+        assert key not in self.notes
         self.notes[key] = note
     def __repr__(self):
         return '<SearchAnalyticsWrapper %i calls made>' % len(self.x)
@@ -186,7 +186,7 @@
         gradApprox = False
         for i in range(len(self.x)):
             y = norm( self.f_x[i] ) + 10**-9
-            if self.notes.has_key(i):
+            if i in self.notes:
                 if self.notes[i] == 'starting gradient approximation':
                     gradApprox = True
                 if self.notes[i] == 'finished gradient approximation':

=== modified file 'viewProviderProxies.py'
--- viewProviderProxies.py	2016-12-02 09:51:42 +0000
+++ viewProviderProxies.py	2017-04-29 20:45:27 +0000
@@ -231,7 +231,7 @@
                 try:
                     if getattr(constraintObj, prop) != getattr( obj, prop):
                         setattr( constraintObj, prop, getattr( obj, prop) )
-                except AttributeError, msg:
+                except AttributeError as e:
                     pass #loading issues...
 
 def repair_tree_view():
@@ -247,13 +247,13 @@
     for m in matches:
         tree_nodes =  get_treeview_nodes(m) 
         def get_node_by_label( label ):
-            if tree_nodes.has_key( label ) and len( tree_nodes[label] ) == 1:
+            if label in tree_nodes and len( tree_nodes[label] ) == 1:
                 return tree_nodes[label][0]
-            elif not tree_nodes.has_key( obj.Label ):
+            elif not obj.Label in tree_nodes:
                 FreeCAD.Console.PrintWarning( "  repair_tree_view: skipping %s since no node with text(0) == %s\n" % ( label, label) )
             else:
                 FreeCAD.Console.PrintWarning( "  repair_tree_view: skipping %s since multiple nodes matching label\n" % ( label, label) )
-        if tree_nodes.has_key( doc.Label ): #all the code up until now has geen to find the QtGui.QTreeView widget (except for the get_node_by_label function)
+        if doc.Label in tree_nodes: #all the code up until now has geen to find the QtGui.QTreeView widget (except for the get_node_by_label function)
             #FreeCAD.Console.PrintMessage( tree_nodes )
             for imported_obj in doc.Objects:
                 try: #allow use of assembly2 contraints also on non imported objects
@@ -285,7 +285,7 @@
     def walk( node ):
         key =  node.text(0)
         #print(key)
-        if not tree_nodes.has_key( key ):
+        if not key in tree_nodes:
             tree_nodes[ key ] = []
         tree_nodes[key].append( node )
         for i in range( node.childCount() ):

